/*
 * Copyright (c) 2023-2024 NVIDIA CORPORATION & AFFILIATES. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at:
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef DOCA_MIRROR_H
#define DOCA_MIRROR_H

#define DOCA_MIRRORS_MAX_TARGETS 2

struct doca_flow_port;
struct doca_mirror_ctx;
struct doca_mirrors;
struct doca_offload_esw_ctx;

struct doca_mirrors *
doca_mirrors_create(struct doca_offload_esw_ctx *esw, struct doca_flow_port *esw_port,
                    uint32_t esw_id);
void
doca_mirrors_destroy(struct doca_mirrors *doca_mirrors);

struct doca_mirror_ctx *
doca_mirror_ctx_ref(struct doca_mirrors *doca_mirrors,
                    struct doca_flow_resource_mirror_cfg *cfg);
void
doca_mirror_ctx_unref(struct doca_mirror_ctx *mirror_ctx);
doca_error_t
doca_mirror_ctx_bind(struct doca_mirror_ctx *mirror_ctx, void *bindable_object,
                     uint32_t *shared_mirror_id);
void
doca_mirrors_bindable_object_released(void *bindable_object);

#endif /* DOCA_MIRROR_H */
